module shpc_open_m

  implicit none

contains

  subroutine shpc_open(hshp, shpc_dir, pszaccess)

    ! Libraries:
    USE jumble, only: new_unit
    use shapelib_03, only: shp_open_03

    use derived_types, only: shpc_slice_handler
    use read_field_indices_m, only: read_field_indices

    TYPE(shpc_slice_handler), intent(out):: hshp
    character(len = *), intent(in):: shpc_dir
    character(len = *), intent(in):: pszaccess ! should be "rb" or "rb+"

    ! Local:
    integer unit
    character(len = 12) orientation

    !--------------------------------------------------------------------

    call shp_open_03(hshp%extremum, shpc_dir // "/extremum", pszaccess)
    call shp_open_03(hshp%outermost, shpc_dir // "/outermost_contour", &
         pszaccess)
    call shp_open_03(hshp%max_speed, shpc_dir // "/max_speed_contour", &
         pszaccess)
    call read_field_indices(hshp)
    call new_unit(unit)
    open(unit, file = shpc_dir // "/orientation.txt", status = "old", &
         action = "read", position = "rewind")
    read(unit, fmt = *) orientation
    close(unit)
    hshp%cyclone = trim(adjustl(orientation)) == "cyclones"
    hshp%dir = shpc_dir
    call new_unit(hshp%unit)

    if (pszaccess == "rb") then
       open(hshp%unit, file = hshp%dir // "/ishape_last.txt", &
            status = "old", action = "read", position = "rewind")
    else
       open(hshp%unit, file = hshp%dir // "/ishape_last.txt", &
            status = "old", action = "readwrite", position = "append")
    end if

  end subroutine shpc_open

end module shpc_open_m
